dojo.provide("custom.CalendarFx");

dojo.require("dijit.dijit"); // loads the optimized dijit layer
dojo.require("dojo.parser"); // scan page for widgets and instantiate them	

dojo.require("dijit._Calendar");
dojo.require("dojox.fx._base");
dojo.require("dojox.widget.Calendar");

dojo.require("dojox.fx");
dojo.require("dojox.widget.CalendarFx");

dojo.declare("custom.CalendarFx", [dojox.widget.Calendar],
{	
	// The path to the template to be used to construct the widget.
	templateString:
	'<div class=\"dojoxCalendar\" style=\"display: none;\" dojoAttachPoint=\"mainCal">\n' +
		'<div tabindex=\"0\" class=\"dojoxCalendarContainer\" style=\"visibility: visible; width: 200px; height 138px;\" dojoAttachPoint=\"container\">\n\t\t' +
		'<div style=\"display:none\">\n\t\t\t<div dojoAttachPoint=\"previousYearLabelNode\"></div>\n\t\t\t' + 
		'<div dojoAttachPoint=\"nextYearLabelNode\"></div>\n\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\">' + 
		'</div>\n\t\t</div>\n<div class=\"dojoxCalendarHeader\" style=\"width: 193px\" dojoAttachPoint=\"monthAndYearNode\">\n<div>\n' + 
		'<div class=\"dojoxCalendarDecrease\" dojoAttachPoint=\"decrementMonth\"><span style=\"color: rgb(169, 169, 169)\"><b>\<\<</b></span></div>\n</div>\n<div class=\"\">\n' +
		'<div class=\"dojoxCalendarIncrease\" dojoAttachPoint=\"incrementMonth\"><span style=\"color: rgb(169, 169, 169)\"><b>\>\></b></span></div>\n</div>\n' +
		'<div class=\"dojoxCalendarTitle\" dojoAttachPoint=\"header\" dojoAttachEvent=\"onclick: onHeaderClick\">\n ' +
		'</div>\n</div>\n<div style=\"height: 151px; overflow: hidden; position: relative; margin: auto; width: 200px;\" dojoAttachPoint=\"containerNode\"></div>\n'  +
		'<div class=\"\">\n' +
			'<div class=\"dojoxCalendarFooter\" dojoAttachPoint=\"footer\" dojoAttachEvent=\"onmouseover: _highlightToday, onmouseout: _deHighlightToday\">\n' +
			'</div>\n' +
			'<div class=\"\" dojoAttachPoint=\"hrsAndMins" style=\"padding-top: 5px; padding-bottom: 5px;\" id=\"timeDiv\"></div>' +
		'</div>\n</div>\n' +
	'</div>\n',
	
	// To capture hours and minutes.
	hrsValue: "",
	minsValue: "",
	hrsCtrl: null,
	minsCtrl: null,
	inputHrsId: "",
	inputMinsId: "",

	// Extension to the calendar control
	extension: "",
	plugin: null,
	dateInput: null,
	dateInputId: "",

	// Render based on properties.
	props: null,
	iconSrc: null,
	runPostCreate: true,

	isTodayClicked: false,
	calCoords: null,
	calIcon: null,
	calIconId: "",
	isIe8: (dojo.isIE && (navigator.userAgent.indexOf("MSIE 8.0") != -1)), 
	isIe6: (dojo.isIE && (navigator.userAgent.indexOf("MSIE 6.0") != -1)),
	
	// Iframe ref.
	iFrame: null,
	
	init: function(extension, props, iconSrc)
	{
		this.extension = extension;
		this.props = props;
		this.iconSrc = iconSrc;
		this.runPostCreate = true;
		this.postCreate();
	},
	
	postCreate: function()
	{
		// proceed if required.
		if (this.runPostCreate)
		{
			if (this.iconSrc == null)
			{
				// Debug.
				alert("Please provide image source to calendar icon.");
				return;
			}
			
			// If extension provided does not exist then alert and halt the execution.
			if (window[this.extension] != undefined && !window[this.extension])
			{
				// Debug.
				alert("Extension " + this.extension + " provoided does not exist.");
				return;
			}
	
			this.inherited(arguments);
			
			// Customize the calendar.
			this._tweakCalendar();
		}
	},

	addFx: function(query, fromNode)
	{
		dojo.query(query, fromNode).forEach(function(curNode) 
		{
			// Workaround to make the dates in bold letters.
			curNode.style.fontSize = "11px";
			
			if(curNode.className == "dojoxCalendarMonthLabel" || curNode.className == "dojoxCalendarYearLabel"){
				curNode.style.paddingTop = "3px";
			}
			// Month and year section has alignment issue for date control on IE. 
			// Forcing the height to be 20px as a workaround. 
			if (dojo.isIE && (window["isDateCtrl"] == "true"))
			{
				curNode.style.height = "20px";
			}
		});
		
		if (this.props != null && this.props.style != "default")
		{
			dojo.query(query, fromNode).onmouseover(function(evt)
			{
				evt.target.style.backgroundColor = "rgb(132, 143, 253)";
			});

			dojo.query(query, fromNode).onmouseout(function(evt)
			{
				evt.target.style.backgroundColor = "";
			});
		}
	},

	onChange: function(/*Date*/date)
	{
		// summary: called only when the selected date has changed					
	},
	
	onValueSelected: function(/*Date*/date)
	{	
		if (this.plugin != null)
		{
			var time;
			
			if (this.isTodayClicked)
			{
				time = 	{"hrs": date.getHours(), "mins": date.getMinutes(), "isToday": true};
			}
			else
			{	
				time = 
				{	
					"hrs": (this.hrsValue.length == 0) ? "0" : this.hrsValue,
					"mins": (this.minsValue.length == 0) ? "0" : this.minsValue,
					"isToday": false
				};
			}
			
			this.plugin.onValueSelected(date, time);	
		}
		
		// if plugin does not put the date in dateinput then make sure date is put in.
		if (this.dateInput.value == "")
		{
			var nDate =  new Date(date);
			this.dateInput.value = nDate;
		}
							
		this._showOrHideCalendar();
		
		((this.props != null) && !(this.props.dateFieldId))
			? this.dateInput.focus()
			: dojo.byId(this.props.dateFieldId).focus();
	},
	
	_tweakCalendar: function()
	{
		var resorceStrings = window.getLocaleStrings();
		
		// Localize Ok and Cancel button
		if (dojo.isIE)
		{
			var btns = document.getElementsByTagName("button");
			
			for (i = 0; i < btns.length; i++)
			{
				if (btns[i].parentNode.className.indexOf("ok-btn") != -1)
				{
					btns[i].innerHTML = resorceStrings.ok;
				}
				
				if (btns[i].parentNode.className.indexOf("cancel-btn") != -1)
				{
					btns[i].innerHTML = resorceStrings.cancel;
				}
			}
		}
		else 
		{
			document.getElementsByClassName("ok-btn")[0].getElementsByTagName("button")[0].innerHTML = resorceStrings.ok;
			document.getElementsByClassName("cancel-btn")[0].getElementsByTagName("button")[0].innerHTML = resorceStrings.cancel;
		}
		
		// In case of multiple calendars in one page, create different ids.
		this._assignUniqueIds();
		
		var dateInputStr = ((this.props != null) && (this.props.showTextBox == 'true'))
			? '<td  valign="top"><input id="' + this.dateInputId + '" disabled/></td>'
			: '<td  valign="top"><input id="' + this.dateInputId + '" style="display: none;" disabled/></td>';
				
		if (this.props != null && this.props.style != "default")
		{
			// Arrange the controls to our needs.
			this.footer.innerHTML = this.footer.innerHTML.replace("Today", resorceStrings.today);			
			this.footer.innerHTML = '<span style="padding: 3px 3px 3px 3px;">' + this.footer.innerHTML + '</span>';
			this.hrsAndMins.innerHTML = 
				'&nbsp;&nbsp;<input type="text" maxlength="2" style="width: 20px" id="'
				+ this.inputHrsId 
				+ '" class="dojoxCalendarContainer" style="cursor: text;">&nbsp;'
				+ resorceStrings.hrs
				+ '&nbsp;&nbsp;&nbsp;<input type="text" maxlength="2" style="width: 20px" id="' 
				+ this.inputMinsId 
				+ '" class="dojoxCalendarContainer" style="cursor: text;">&nbsp;'
				+ resorceStrings.mins
				+ '</div>';
		}
		
		var temp = document.createElement("div");
		temp.innerHTML = 
		'<table cellspacing=0 cellpadding=0><tr>' +
			dateInputStr +
			'<td valign="top" id="' + this.calIconId + '"><img src="' + this.iconSrc + '"/></td>' +
		'</tr></table>';

		this.mainCal.parentNode.insertBefore(temp, this.mainCal);
		this.dateInput = dojo.byId(this.dateInputId);
		this.calIcon = dojo.byId(this.calIconId);
		
		if ((this.props != null) && (this.props.disableTextBox != 'true'))
		{
			this.dateInput.disabled = false;
		}

		this._registerExtension();
		if (this.plugin != null)
		{
			if ((this.props != null) && (this.props.dateFieldId))
			{
				// Populate the entered date in this field.
				this.plugin.init(dojo.byId(this.props.dateFieldId));
			}
			else
			{
				this.plugin.init(this.dateInput);
			}
		}

		// FIXME: Add a css class to mainCal; not working as expected if css is added.
		this.mainCal.style.zIndex = 1999;
		this.mainCal.style.position = "absolute";					
		this.mainCal.style.display = "none";
		
		((this.props != null) && (this.props.initialDisplay == 'show'))
			? this.show()
			: this.hide();
		
		this._asscociateEvents();
	},

	_asscociateEvents: function()
	{
		if (this.props != null && this.props.style != "default")
		{
			
			this.hrsCtrl = dojo.byId(this.inputHrsId);
			this.minsCtrl = dojo.byId(this.inputMinsId);

			// Capture hours and minutes.
			dojo.connect(this.hrsCtrl, "onchange",  this, function()
			{
				this.hrsValue = this.hrsCtrl.value;
			});
			
			dojo.connect(this.hrsCtrl, "onmouseover",  this, function()
			{						
				this.hrsCtrl.style.cursor = "text"; 
			});

			dojo.connect(this.minsCtrl, "onchange",  this, function()
			{
				this.minsValue = this.minsCtrl.value;
			});
			
			dojo.connect(this.minsCtrl, "onmouseover",  this, function()
			{						
				this.minsCtrl.style.cursor = "text"; 
			});
			
			dojo.connect(this.hrsCtrl, "onkeypress",  this, function(event)
			{						
				if (event.keyCode == 13) 
				{
					event.preventDefault();
				}
			});
			
			dojo.connect(this.minsCtrl, "onkeypress",  this, function(event)
			{						
				if (event.keyCode == 13) 
				{
					event.preventDefault();
				}
			});
		}
		
		// Show or hide calendar icon		
		dojo.connect(this.calIcon, "onmouseover", this, function()
		{
			this.calIcon.style.cursor = "pointer";
		});

		dojo.connect(this.calIcon, "mousedown", this, function(evt)
		{
			this._showOrHideCalendar();			
		});
		
		dojo.connect(document, "onclick", this, function(evt)
		{
			this._hideCalendarOnWindowClick(evt);
		});

		dojo.connect(this.footer, "onmousedown", this, function()
		{
			this.isTodayClicked = true;
		});
	},

	_highlightToday: function()
	{
		if (this.props != null && this.props.style != "default") 
		{
			this.footer.firstChild.style.backgroundColor = "rgb(132, 143, 253)";
		}
	},
	
	_deHighlightToday: function()
	{
		if (this.props != null && this.props.style != "default")
		{
			this.footer.firstChild.style.backgroundColor = "";
		}
	},

	_hideCalendarOnWindowClick: function(evt)
	{		
		var elem = this._getTarget(evt);
		var calClicked = false;
		
		do
		{
			if ((elem == this.mainCal) || (elem.id == this.calIconId))
			{
				calClicked = true;
				break;
			}
			
			elem = elem.parentNode;
		} while (elem)
			
		if (!calClicked) 
		{
			this.mainCal.style.display = "none";
			if (this.isIe6) this._removeIframe();
		}
	},
	
	_showOrHideCalendar: function(forceHide)
	{
		var cal = this.mainCal;
		
		if (((forceHide != undefined) && (forceHide == true)) || cal.style.display == "")
		{
			dojo.fx.wipeOut({
				node: cal,
				duration: 250
			}).play();
			
			// On IE 8 month and year section does not go away. This is just a workaround.
			if (this.isIe8) this.monthAndYearNode.style.visibility = "hidden";
			this.isTodayClicked = false;
			
			if (this.isIe6) this._removeIframe();
		}
		else
		{
			// Make the fields blank.
			dojo.byId(this.inputHrsId).value = "";
			dojo.byId(this.inputMinsId).value = "";
			this.hrsValue = "0";
			this.minsValue = "0";
			
			var top;
						
			// Display calendar with respective control.
			if ((this.props != null) && (this.props.showTextBox == 'true'))
			{
				coordCtrl = this.dateInput;
			}		
			else if ((this.props != null) && (this.props.dateFieldId))
			{
				coordCtrl = dojo.byId(this.props.dateFieldId);
			}
			else if ((this.props != null) && (this.props.showTextBox == 'false'))
			{
				coordCtrl = this.calIcon;
			}
			
			this.calCoords = dojo.coords(coordCtrl, true);
			cal.style.left = parseInt(this.calCoords.x) + "px";
			cal.style.top = parseInt(this.calCoords.y) + parseInt(coordCtrl.clientHeight) + 4 + "px"; 
			
			dojo.fx.wipeIn(
			{
				node: cal,
				duration: 250
			}).play();
			
			// On IE 8 month and year section does not go away. This is just a workaround.
			if (this.isIe8) this.monthAndYearNode.style.visibility = "visible";
			
			if (this.isIe6) this._showIframe();
			
		}
	},

	_registerExtension: function()
	{
		if (window[this.extension] != null && this.extension != "")
		{												
			// Instantiation of extension class.
			this.plugin = new window[this.extension]();				
		}		
	},
	
	_assignUniqueIds: function()
	{
		var i = 1;
		
		this.calIconId = "calIcon";
		if (dojo.byId(this.calIconId))
		{
			for (;; i++)
			{
				this.calIconId += "" + i;
				if (!dojo.byId(this.calIconId)) break;
			}
		}
		
		this.dateInputId = "inputDate";
		if (dojo.byId(this.dateInputId))
		{
			i = 1;
			for (;; i++)
			{
				this.dateInputId += "" + i;
				if (!dojo.byId(this.dateInputId)) break;
			}
		}
		
		this.inputHrsId = "inputHrs";
		if (dojo.byId(this.inputHrsId))
		{
			i = 1;
			for (;; i++)
			{
				this.inputHrsId += "" + i;
				if (!dojo.byId(this.inputHrsId)) break;
			}
		}
		
		this.inputMinsId = "inputMins";
		if (dojo.byId(this.inputMinsId))
		{
			i = 1;
			for (;; i++)
			{
				this.inputMinsId += "" + i;
				if (!dojo.byId(this.inputMinsId)) break;
			}
		}
	},
	
	_getTarget: function(evt)
	{
		return (window.event)
			? window.event.srcElement
			: evt.target;
	},
	
	
	/**
	 * Divs are shown behind listbox or dropbown lists in IE6
	 * as a workaround show an iframe behing div. 
	 */
	_showIframe: function()
	{
		this.iFrame = document.createElement("IFRAME");
		
		// https gives security warning. Add src as blank page to avoid it.
		this.iFrame.setAttribute("src", window.getBlankPagePath());

		//Match IFrame position with calendar
		this.iFrame.style.position = "absolute";
		this.iFrame.style.left = this.mainCal.offsetLeft + 'px';
		this.iFrame.style.top = this.mainCal.offsetTop + 'px';
		this.iFrame.style.width = this.mainCal.offsetWidth + 'px';
		this.iFrame.style.height = 212 + 'px';		

		document.body.appendChild(this.iFrame);
	},
	
	_removeIframe: function()
	{
		if (this.iFrame && this.iFrame != null)
		{
			document.body.removeChild(this.iFrame);
			this.iFrame = null;
		}
	},
	
	getPlugin: function()
	{
		if (this.plugin != null)
		{
			return this.plugin;
		}
		else
		{
			// Debug
			alert("Please initialize " + this.extension);
			return false;
		}

	}, 
	
	show: function()
	{
		if ((this.props != null) 
			&& !(this.props.showTextBox != "true") 
			&& (this.dateInput.style.display == "none"))
		{
			this.dateInput.style.display = "";
		}
		
		if (this.calIcon.style.display  == "none")
		{
			this.calIcon.style.display = "";
		}		
	},
	
	hide: function()
	{
		if (this.dateInput.style.display == "")
		{
			this.dateInput.style.display = "none";
		}
		
		if (this.calIcon.style.display  == "")
		{
			this.calIcon.style.display = "none";
		}
	},
	
	hideCalendarContainer: function()
	{
		if (this.mainCal.style.display == "")
		{
			this.mainCal.style.display = "none";
		}
	}
});
